#include "csr.h"
#include "rv32cpu.h"

uint32_t csr_read(struct RV32_CPU* cpu, uint32_t csr)
{
	switch(csr)
	{
		case CSR_CYCLE:
			return cpu->sim_ticks_done;
		case CSR_SSTATUS:
			return csr_read(cpu, CSR_MSTATUS);
		case CSR_SIE:
			return csr_read(cpu, CSR_MIE);
		case CSR_SIP:
			return csr_read(cpu, CSR_MIP);
		default:
			break;
	}

	return cpu->csr[csr];
}

void csr_write(struct RV32_CPU* cpu, uint32_t csr, uint32_t value)
{
	switch(csr)
	{
		case CSR_SSTATUS:
			csr_write(cpu, CSR_MSTATUS, value);
			return;
		case CSR_SIE:
			csr_write(cpu, CSR_MIE, value);
			return;
		case CSR_SIP:
			csr_write(cpu, CSR_MIP, value);
			return;
		default:
			break;
	}
	cpu->csr[csr] = value;
}
